#! /usr/bin/env python
# -*- Mode: python -*-
#
# Copyright 2012 IFIC (Instituto de Fisica Corpuscular). Distributed under the GPL.
# Author: Victor Ruben Lacort Pellicer <Victor.Lacort@ific.uv.es>
#===================================================================================
#
# lustre-file2ost-oss.py: Obtiene la lista de OSTs en los que reside un fichero
#
#===================================================================================

import sys, os, re
import time
import socket
import getopt

def usage ():

    print >> sys.stderr, "uso: %s [opciones] fichero" % sys.argv[0]
    print >> sys.stderr, "opciones:"
    print >> sys.stderr, "  -h, --help            muestra este mensaje y sale"
    print >> sys.stderr, "  -v, --verbose         salida detallada"
                                            
def getLustreOSShostCli(fs, ost, idfs):

    #osts=[]
    try:
        f=open("/proc/fs/lustre/osc/%s-%s-osc-%s/ost_conn_uuid"%(fs,ost,idfs),'r')
    except:
        print >> sys.stderr, "No puedo obtener la informacion del sistema de ficheros ",fs
        sys.exit(2)
        #return obdl
    #print "%s %s %s"%(fs,ost,idfs)###
    for l in f:
        host = l.rstrip().replace("@tcp","")
        r = socket.gethostbyaddr(host)
        #osts.append("%s %s"%(r[0],host))
#        print "%s\t\t%s\t%s"%(ost,r[0].split('.')[0],host)
        res = "%s\t\t%s" %(ost,r[0].split('.')[0])
    f.close()
    return res


def main():

    try:
        opts, args = getopt.getopt(sys.argv[1:], "hv", ["help", "verbose"])
    except getopt.GetoptError, err:
        # print help information and exit:
        print str(err) # will print something like "option -a not recognized"
        usage()
        sys.exit(2)
        

    verbose = False
#    print "opts"
#    print opts

#    print "args"
#    print args

    for o, a in opts:
        if o in ("-v", "--verbose"):
            verbose = True
        elif o in ("-h", "--help"):
            usage()
            sys.exit()
        else:
            assert False, "unhandled option"

    if len(args) == 0:
        usage()
        sys.exit()
        
    #fname = args[0]
    #print fname

    for fich in args:
        flag  = 0
        parts = []
        osts  = {}

        fname = fich

        if not os.path.isfile(fname):
            print >> sys.stderr, "No existe el fichero %s" % fname
            sys.exit()

        f = os.popen ("/usr/bin/lfs getstripe %s" % fname)
        for l in f:
            tk=l.strip().split()
            if len(tk) == 0:
                continue
            if tk[0] == "OBDS:" :
                continue
            if tk[0] == fname :
                flag = 1
                continue
            if flag == 0 :
                (n, ost, status) = tk
                n  = n.rstrip(":")
                ost = ost.replace("_UUID","")
                #Cogemos el nombre de fs lustre y la lista de osts
                (fs, id) = ost.split('-')
                osts[n] = id
            if flag == 1 :
                if tk[0] == "obdidx":
                    continue
                if len(tk) != 0 :
                    obdidx = tk[0]
                    parts.append(obdidx)
        f.close()


        #Cogemos el identificador raro de 'lctl dl': 3 UP osc testfs-OST0000-osc-ffff8100ed9aa000 <- ese 'ffff8100ed9aa000'
        #idfs = "ffff8100ed9aa000" #solucion rapida para pruebas
        f = os.popen ("lctl dl")
        for l in f:
            (n, status, tipo, name, ext, num) = l.rstrip().split( )
	    if tipo != "osc":
                continue
            (fsdl, ost, tipo2, idfs) = name.split('-')
            if fsdl == fs:
                break
        f.close()

        #Cogemos los OSTs indicados por 'parts'
        if verbose:
            print "\nFilesystem name: %s" % fs 
            print "File name: %s" % fname
            #print ""
            print "OSTs\t\tOSSs\t\tFile"
            print "-------------------------------------------------------"
        flag_fname = 0  #para no sacar varias veces el fname en caso de stripping
        for p in parts:
            s = getLustreOSShostCli(fs, osts[p], idfs)
            if flag_fname == 0:
                s += "\t\t" + fname
                flag_fname = 1
            print s
#fin
###################################

if __name__ == '__main__':
    main()

